﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using System.Diagnostics;

namespace LWP.NavigationSamples
{
    public partial class AllNavigationEvents : PhoneApplicationPage
    {
        public AllNavigationEvents()
        {
            InitializeComponent();
            this.Loaded += new RoutedEventHandler(AllNavigationEvents_Loaded);
            this.instanceId = nextId++; 
        }

        void AllNavigationEvents_Loaded(object sender, RoutedEventArgs e)
        {
            Debug.WriteLine("Loaded " + instanceId);
            if (nextId == 1)
            {
                ((PhoneApplicationFrame)App.Current.RootVisual).Navigating += new System.Windows.Navigation.NavigatingCancelEventHandler(AllNavigationEvents_Navigating);
                ((PhoneApplicationFrame)App.Current.RootVisual).Navigated += new System.Windows.Navigation.NavigatedEventHandler(AllNavigationEvents_Navigated);
                ((PhoneApplicationFrame)App.Current.RootVisual).NavigationStopped += new System.Windows.Navigation.NavigationStoppedEventHandler(AllNavigationEvents_NavigationStopped);
            }

            PageTitle.Text = "Instance " + instanceId;

            backButton.IsEnabled = NavigationService.CanGoBack;
            forwardButton.IsEnabled = NavigationService.CanGoForward; 

        }

        void AllNavigationEvents_NavigationStopped(object sender, System.Windows.Navigation.NavigationEventArgs e)
        {
            Debug.WriteLine("Navigation Stopped " + e.Uri); 
        }

        void AllNavigationEvents_Navigated(object sender, System.Windows.Navigation.NavigationEventArgs e)
        {
            Debug.WriteLine("Navigated to " + e.Uri); 
        }

        void AllNavigationEvents_Navigating(object sender, System.Windows.Navigation.NavigatingCancelEventArgs e)
        {
            Debug.WriteLine("Navigating to " + e.Uri); 
        }

        protected override void OnNavigatedFrom(System.Windows.Navigation.NavigationEventArgs e)
        {
            base.OnNavigatedFrom(e);
            Debug.WriteLine("OnNavigatedFrom " + instanceId); 
        }

        protected override void OnNavigatedTo(System.Windows.Navigation.NavigationEventArgs e)
        {
            base.OnNavigatedTo(e);
            Debug.WriteLine("OnNavigatedTo " + instanceId); 
        }

        void OnBack(object unused, RoutedEventArgs unused2)
        {
            if (NavigationService.CanGoBack)
                NavigationService.GoBack(); 

        }

        void OnForward(object unused, RoutedEventArgs unused2)
        {
            if (NavigationService.CanGoForward)
                NavigationService.GoForward();

        } 

        static int nextId;
        int instanceId; 

        void OnNavigateNext(object unused, RoutedEventArgs unused2)
        {
            string next = string.Format("/AllNavigationEvents.xaml?nextId={0}", nextId);
            Uri uri = new Uri(next, UriKind.Relative);
            this.NavigationService.Navigate(uri);

        } 
    }
}